﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls.ScheduleView;
using System.Collections.ObjectModel;
using System.Collections;
using Telerik.Windows.Controls;
using System.Windows.Input;
using System.Windows.Threading;
using System.ComponentModel;
using System.Threading;
using System.Windows;

namespace WPF_ScheduleView
{
	public class ViewModel : ViewModelBase
	{
		private BackgroundWorker bw;
		private bool isLoading;

		public ViewModel()
		{
			this.IsLoading = true;
			this.DummyLoadingAppointments = new ObservableAppointmentCollection();
			var timer = new DispatcherTimer();
			timer.Interval = new TimeSpan(0, 0, 5);
			timer.Tick += (s, e) =>
				{
					timer.Stop();
					this.Appointments.AddRange(this.GetAppointments());
					this.IsLoading = false;
				};
			timer.Start();

			this.Appointments = new ObservableCollection<Appointment>();
			this.DummyLoadingAppointments = new ObservableAppointmentCollection
			{
				new Appointment {Subject = "New app 1", Start = DateTime.Now, End = DateTime.Now.AddHours(1)},
				new Appointment {Subject = "New app 2", Start = DateTime.Now.AddHours(2), End = DateTime.Now.AddHours(3)},
			};

			this.bw = new BackgroundWorker();
			this.bw.RunWorkerCompleted += bw_RunWorkerCompleted;
			this.bw.DoWork += bw_DoWork;
			this.bw.RunWorkerAsync();
		}

		public bool IsLoading
		{
			get
			{
				return this.isLoading;
			}
			set
			{
				if (this.isLoading != value)
				{
					this.isLoading = value;
					this.OnPropertyChanged(() => this.IsLoading);
				}
			}
		}

		public ICommand LoadAppointments { get; private set; }

		public ObservableAppointmentCollection DummyLoadingAppointments
		{
			get;
			private set;
		}

		public ObservableCollection<Appointment> Appointments
		{
			get;
			private set;
		}

		private void bw_DoWork(object sender, DoWorkEventArgs e)
		{
			Thread.Sleep(9000);
		}

		private void bw_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
		{
			this.Appointments.AddRange(this.DummyLoadingAppointments);
		}

		private IEnumerable<Appointment> GetAppointments()
		{
			return new ObservableAppointmentCollection
			{
				new Appointment {Subject = "Basic app 1", Start=DateTime.Today.AddHours(1), End = DateTime.Today.AddHours(2) },
				new Appointment {Subject = "Basic app 2", Start=DateTime.Today.AddHours(3), End = DateTime.Today.AddHours(4) },
				new Appointment {Subject = "Basic app 3", Start=DateTime.Today.AddHours(5), End = DateTime.Today.AddHours(6) },
				new Appointment {Subject = "Basic app 4", Start=DateTime.Today.AddHours(7), End = DateTime.Today.AddHours(8) },
				new Appointment {Subject = "Basic app 5", Start=DateTime.Today.AddHours(9), End = DateTime.Today.AddHours(10) },
			};
		}
	}
}
